/*
 * Copyright (C) 2010 Leandro Aparecido <lehphyro@gmail.com>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.google.code.mjl;

/**
 * Features printf style message format.
 */
public interface Log {

	enum Level {
		TRACE, DEBUG, INFO, WARN, ERROR, FATAL,
	}

	boolean enabled(Level level);

	void trace(String formatMessage, Object... formatParams);

	void trace(Throwable t, String formatMessage, Object... formatParams);

	void debug(String formatMessage, Object... formatParams);

	void debug(Throwable t, String formatMessage, Object... formatParams);

	void info(String formatMessage, Object... formatParams);

	void info(Throwable t, String formatMessage, Object... formatParams);

	void warn(String formatMessage, Object... formatParams);

	void warn(Throwable t, String formatMessage, Object... formatParams);

	void error(String formatMessage, Object... formatParams);

	void error(Throwable t, String formatMessage, Object... formatParams);

	void fatal(String formatMessage, Object... formatParams);

	void fatal(Throwable t, String formatMessage, Object... formatParams);

	void log(Level level, boolean async, String formatMessage, Object... formatParams);

	void log(Level level, Throwable t, boolean async, String formatMessage, Object... formatParams);

}
