/*
 * Copyright (C) 2010 Leandro Aparecido <lehphyro@gmail.com>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.google.code.mjl.formatter.impl;

import java.util.*;

import com.google.code.mjl.formatter.*;

public class DefaultMessageFormatter implements MessageFormatter {

	private final Formatter formatter;

	public DefaultMessageFormatter(Locale locale) {
		formatter = new Formatter(locale);
	}

	public String format(String format, Object... args) {
		StringBuilder sb = (StringBuilder) formatter.out();
		try {
			formatter.format(format, args);
			return sb.toString();
		} finally {
			sb.setLength(0);
		}
	}
}
