/*
 * Copyright (C) 2010 Leandro Aparecido <lehphyro@gmail.com>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.google.code.mjl.guice;

import java.lang.annotation.*;
import java.lang.reflect.*;

import com.google.code.mjl.util.*;
import com.google.inject.matcher.*;

public class AnnotationAnnotatedMatcher<T extends AnnotatedElement> extends AbstractMatcher<T> {

	private Class<? extends Annotation> annotationType;

	public AnnotationAnnotatedMatcher(Class<? extends Annotation> annotationType) {
		this.annotationType = annotationType;
		Annotations.checkForRuntimeRetention(annotationType);
	}

	@Override
	public boolean matches(T t) {
		return Annotations.getAnnotation(t, annotationType) != null;
	}

}
