/*
 * Copyright (C) 2010 Leandro Aparecido <lehphyro@gmail.com>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.google.code.mjl.guice;

import java.lang.reflect.*;

import org.aopalliance.intercept.*;

import com.google.code.mjl.*;
import com.google.code.mjl.tracing.*;
import com.google.inject.*;
import com.google.inject.matcher.*;

public class TracingModule extends AbstractModule {

	@Override
	protected void configure() {
		MethodInterceptor interceptor = new TracingInterceptor();
		Matcher<AnnotatedElement> matcher = new AnnotatedMemberOrTypeMatcher(Trace.class);

		bindInterceptor(Matchers.any(), matcher, interceptor);
		bindListener(Matchers.any(), new InjectLogTypeListener());
	}

}
