/*
 * Copyright (C) 2010 Leandro Aparecido <lehphyro@gmail.com>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.google.code.mjl.impl;

import java.io.*;
import java.util.*;

public class LogUtils {

	private static final int LOG_EVENT_INITIAL_SIZE = 100;

	private LogUtils() {
	}

	public static String toString(LogEvent logEvent) {
		StringWriter sw = new StringWriter(LOG_EVENT_INITIAL_SIZE);
		PrintWriter writer = new PrintWriter(sw);
		toString(logEvent, writer);
		writer.close();

		return sw.toString();
	}

	public static void toString(LogEvent logEvent, PrintWriter writer) {
		writer.append(logEvent.level().name());
		writer.append(" [");
		writer.append(new Date(logEvent.time()).toString());
		writer.append("]: ");
		writer.append(logEvent.threadName());
		writer.append(" > ");
		writer.append(logEvent.categoryName());
		writer.append(" - ");
		writer.append(logEvent.message());
		if (logEvent.throwable() != null) {
			writer.append('\n');
			logEvent.throwable().printStackTrace(writer);
		}
	}

}
